/**
 * \file mgui/dlgviewextents.h
 * \brief MGUI::DLG_VIEWOBJEXTENTS class definitions.
 *
 * \if NODOC
 * $Id: dlgviewextents.h_v 1.8 2011/11/09 14:53:40 mju Exp $
 *
 * $Log: dlgviewextents.h_v $
 * Revision 1.8  2011/11/09 14:53:40  mju
 * Use trans2dmapgen hdr.
 *
 * Revision 1.1  2003/06/02 19:23:17  scowan
 * Initial revision
 * \endif
**/

#ifndef	INC_MGUI_DLGVIEWEXTENTS_H
#define	INC_MGUI_DLGVIEWEXTENTS_H

#ifndef INC_MGUI_DLGSHELL_H
#include <mgui/dlgshell.h>
#endif

#ifndef INC_MGUI_FORMBTXT_H
#include <mgui/formbtxt.h>
#endif

#ifndef INC_MGUI_COMBOBOX_H
#include <mgui/combobox.h>
#endif

#ifndef INC_RVC_OBJITEM_H
#include <rvc/objitem.h>
#endif

#ifndef INC_MI32_TRANS2DMAPGEN_H
#include <mi32/trans2dmapgen.h>
#endif

#ifndef INC_MI32_SPATREF_H
#include <mi32/spatref.h>
#endif


namespace MGUI {
//===================================================================================================================
//! Dialog for viewing object extents.
class DLG_VIEWOBJEXTENTS : public DLGSHELL {
	public:

		//! Constructor.
		DLG_VIEWOBJEXTENTS ();

		//! Destructor.
		virtual ~DLG_VIEWOBJEXTENTS ();

		//! Set object to display extents from
		ERRVALUE SetObject (
			const RVC::OBJITEM& ObjItem,
			const RVC::OBJECTNAME& GeorefName
			);

	private:
		#ifndef GENERATING_DOXYGEN_OUTPUT
		RVC::OBJITEM m_ObjItem;
		RVC::OBJECTNAME m_GeorefName;
		DRECT3D m_Extents;
		SPATREF::COORDREFSYS m_CoordRefSys;
		TRANS2D_MAPGEN m_tmg;
		bool m_UserSelectedProj;
		CTRL_TEXT m_TextCtrl;
		FORM_BUTTONTEXT m_BtxCoordRefSys;
		FORM_COMBOBOX m_CbxUnits;
		CTRL_PUSHBUTTON m_BtnSelect;
		CTRL_PUSHBUTTON m_BtnSaveAs;

		//! Overrides from DLGSHELL.
		virtual ERRVALUE v_CreateContent ();
		virtual void v_OnOpen ();
		
		ERRVALUE GenInfoText (MISTRING& string);
		void OnProjectionSelect ();
		void OnObjectSelect ();
		void OnSaveAs ();
		void OnUnitSelect ();
		void SetUnits ();
		void UpdateDisplay ();
		#endif // GENERATING_DOXYGEN_OUTPUT
	};

//===================================================================================================================
}	// End namespace MGUI

#endif	// INC_MGUI_DLGTEXTV_H
