/**
 * \file mi32/rvcstyle.h
 * \brief Definitions for Style objects
 *
 * \if NODOC
 * $Id: rvcstyle.h_v 1.104 2011/11/04 13:47:35 mju Exp $
 *
 * $Log: rvcstyle.h_v $
 * Revision 1.104  2011/11/04 13:47:35  mju
 * Remove redundant hdr.
 *
 * Revision 1.103  2007/05/08 16:09:13  dwilliss
 * forward decl filepath
 *
 * Revision 1.102  2007/04/09 15:56:23  scowan
 * Removed legacy include file.
 *
 * Revision 1.101  2007/03/09 23:55:42  scowan
 * Removed all legacy functions.
 *
 * Revision 1.100  2007/03/08 16:26:08  scowan
 * Moved header to private include file.
 *
 * Revision 1.99  2007/03/08 16:00:45  scowan
 * Removed unused inlines.
 *
 * Revision 1.98  2007/01/02 16:31:43  scowan
 * Removed mfStyleMake.
 *
 * Revision 1.97  2006/12/27 18:18:27  scowan
 * Marked legacy make function as removable.
 *
 * Revision 1.96  2006/11/08 15:22:42  scowan
 * Remogved unused defines for pattern color.
 *
 * Revision 1.95  2006/10/26 20:43:12  dwilliss
 * Got rid of some prototypes that are no longer used
 *
 * Revision 1.94  2006/09/20 17:06:51  scowan
 * Deprecated many structures.
 *
 * Revision 1.93  2006/06/26 12:49:21  mju
 * Don't show deprecation warnings within deprecated inlines.
 *
 * Revision 1.92  2006/06/23 20:11:49  scowan
 * Removed unused functions.
 *
 * Revision 1.91  2006/06/23 15:31:07  scowan
 * Removed legacy function prototypes.
 *
 * Revision 1.90  2005/12/21 00:09:22  scowan
 * Removed unused exported function.
 *
 * Revision 1.89  2005/03/31 16:57:20  fileserver!dwilliss
 * Rename one of our types to MIUNICODE because it conflicted with a Microsoft #define
 *
 * Revision 1.88  2004/09/03 16:02:07  scowan
 * Removed unused items.
 *
 * Revision 1.87  2004/04/03 00:00:12  scowan
 * Moved unused prototypes to private include file.
 *
 * Revision 1.86  2004/04/02 23:28:49  scowan
 * Fixed deprecation.
 *
 * Revision 1.85  2004/04/02 22:14:34  scowan
 * Removed unused prototypes and make more functions deprecated.
 *
 * Revision 1.84  2004/04/02 16:59:21  scowan
 * Added more thingsd to be deprecated.
 *
 * Revision 1.83  2004/04/02 16:51:03  scowan
 * Removed unused prototype for combine styles.
 *
 * Revision 1.82  2004/03/31 18:35:01  dwilliss
 * Added versions of functions that take MISTRING instead of text font name,
 * which I'm about to deprecate
 *
 * Revision 1.81  2004/03/11 16:57:47  mju
 * Eliminate old obj selection dialogs as no longer used.
 *
 * Revision 1.80  2004/03/10 17:08:43  dwilliss
 * Added a polygons member to SYMBOLDATA
 *
 * Revision 1.79  2004/03/10 15:45:17  dwilliss
 * Added some new point symbol element types
 *
 * Revision 1.78  2003/10/15 17:39:35  mju
 * Deprecate groupkey.
 *
 * Revision 1.77  2003/09/25 21:29:07  dwilliss
 * Don't capitalize enum any more. Genitor needed it, doxygen doesn't like it.
 *
 * Revision 1.76  2003/09/15 13:49:56  fileserver!dwilliss
 * Doxygen
 *
 * Revision 1.75  2003/03/03 15:28:33  mju
 * Add variants on MfImportPointSymbol... using RVC::STYLE.
 *
 * Revision 1.74  2003/01/31 18:41:05  scowan
 * nc.
 *
 * Revision 1.73  2002/11/21 20:31:37  dwilliss
 * Added new HATCHPATTELEM constant
 *
 * Revision 1.72  2002/10/16 19:22:57  dwilliss
 * Prototype for new function
 *
 * Revision 1.71  2002/09/09 13:59:02  mju
 * Always prevent_memfunc.
 * Retire previously deprecated stuff.
 *
 * Revision 1.70  2002/08/22 16:20:35  scowan
 * More functions.
 *
 * Revision 1.69  2002/08/22 14:51:55  scowan
 * Added object name versions of style functions.
 *
 * Revision 1.68  2002/08/21 22:40:16  dwilliss
 * Correction to previous revision.  Needed to take a TEXTFONTNAME, not
 * RVC::OBJECTNAME
 *
 * Revision 1.67  2002/08/21 22:31:54  dwilliss
 * MfFontTransIndexToName() -- Made a version that takes RVC::OBJECTNAME to
 * fill in and deprecated the one that filled in a MIUNICODE*
 *
 * Revision 1.66  2002/08/21 20:38:57  scowan
 * Deprecate old object name define.
 *
 * Revision 1.65  2002/08/20 15:18:50  mju
 * Use prevent_memfunc macro, still checks no_deprecated.
 *
 * Revision 1.64  2002/05/23 20:04:45  scowan
 * Added add pattern function.
 *
 * Revision 1.63  2002/05/23 19:52:15  scowan
 * Added read pattern ext function.
 *
 * Revision 1.62  2002/04/16 19:12:56  dwilliss
 * Never mind...
 *
 * Revision 1.61  2002/03/08 23:16:17  scowan
 * Added fields to texzt style.
 *
 * Revision 1.60  2002/03/08 23:03:32  scowan
 * Added more ctors and other methods.
 *
 * Revision 1.59  2002/03/08 18:56:46  scowan
 * Added clear method.
 * delrecate mem... for struct info's.
 *
 * Revision 1.58  2001/12/20 21:48:30  mju
 * Enum docs.
 *
 * Revision 1.57  2001/09/14 14:58:36  mju
 * No Mdlg in win32native.
 *
 * Revision 1.56  2001/08/31 20:01:38  scowan
 * Added write style name function.
 *
 * Revision 1.55  2001/08/28 15:22:10  mju
 * Fix search/replace goof.
 *
 * Revision 1.54  2001/08/28 14:56:26  mju
 * Add MfStyleAdd() functions.
 *
 * Revision 1.53  2001/08/28 14:29:43  mju
 * Change RVCPOLYSTYLE to RVCPOLYGONSTYLE with typedef for old name.
 *
 * Revision 1.52  2001/08/15 16:09:11  mju
 * Change STYLETYPE and PATTERNTYPE to enums.
 *
 * Revision 1.51  2001/03/06 22:55:57  vdronov
 * added STYLETYPE_Empty = 0xFFFF
 *
 * Revision 1.50  2000/11/06 18:51:34  msmith
 * Genitor documentation.
 *
 * Revision 1.49  2000/07/07 20:53:11  scowan
 * Create filepath version of get style.
 *
 * Revision 1.48  2000/05/24 22:30:01  dwilliss
 * Added 2 new prototypes
 *
 * Revision 1.47  2000/04/27 17:18:38  mju
 * Define RVCPATTHDR struct and have other pattern headers inherit from it.
 *
 * Revision 1.46  2000/04/14 14:54:31  scowan
 * *** empty log message ***
 *
 * Revision 1.45  1999/11/19 14:30:27  mju
 * MdlgGet... prompt const.
 *
 * Revision 1.44  1999/10/18  21:06:27  mju
 * Remove RVCANYSTYLE union.
 *
 * Revision 1.43  1999/10/18  17:07:46  mju
 * Make MfStyleRead/WriteXxxx inline so they are typesafe.
 * Add MfStyleRead() and MfStyleWrite() inlines.
 *
 * Revision 1.42  1999/10/05  22:48:35  scowan
 * Changed headers to use inheritance.
 *
 * Revision 1.41  1999/08/05 21:16:35  mju
 * Use const for FindPattern and StyleLocate.
 *
 * Revision 1.40  1999/06/29  21:31:48  mju
 * Add CopyStyleRVCtoMem for text style.
 *
 * Revision 1.39  1999/06/11  14:46:29  mju
 * Obj sel dlg.
 *
 * Revision 1.38  1999/06/10  22:11:23  mju
 * Object selection dialog update.
 *
 * Revision 1.37  1999/05/07  21:23:41  mju
 * Hdr restruct.
 *
 * Revision 1.36  1999/02/17  18:47:59  mju
 * Add CopyStyle prototypes.
 *
 * Revision 1.35  1999/01/05  19:13:20  scowan
 * Swapped multiple keywords
 *
 * Revision 1.34  1998/11/06 22:11:44  dfrolov
 * rearange fields in HATCHPATTELEMENT structure
 *
 * Revision 1.33  1998/10/28  22:44:03  dfrolov
 * some changes in hatch patterns
 *
 * Revision 1.32  1998/10/23  19:07:41  dfrolov
 * add support for hatch patterns
 *
 * Revision 1.31  1998/09/30  21:54:41  scowan
 * Setup DLL.
 *
 * Revision 1.30  1998/09/25  22:46:20  scowan
 * Fixed for DLL.
 *
 * Revision 1.29  1998/09/23  23:12:31  scowan
 * *** empty log message ***
 *
 * Revision 1.28  1998/08/03  13:47:34  dwilliss
 * Changed a UINT8 spare[4] to FLOAT width
 *
 * Revision 1.27  1997/10/31  17:26:16  dfrolov
 * attempted to add new elements for symbols
 *
 * Revision 1.26  1997/06/20  19:56:53  scowan
 * Added Predefined.
 *
 * Revision 1.25  1996/12/20  16:37:34  coffee!dwilliss
 * Added __cplusplus things
 *
 * Revision 1.24  1996/07/13  00:18:12  mju
 * Remove MxFillPolygonBitmap prototypes as obsolete.
 *
 * Revision 1.23  1996/03/07  21:53:22  scowan
 * Added _MfWriteStyleRaw().
 *
 * Revision 1.22  1996/02/22  22:33:44  scowan
 * Added MfDeleteStyleType().
 *
 * Revision 1.21  1996/01/23  05:28:34  scowan
 * Added MfReplaceStyle().
 *
 * Revision 1.20  1996/01/17  16:59:24  coffee!dwilliss
 * Prototyped MfReadStyleName()
 *
 * Revision 1.19  1995/12/13  23:10:21  mju
 * Remove MfMakeDftStyleTable() prototype.
 *
 * Revision 1.18  1995/12/05  22:44:19  coffee!dwilliss
 * *** empty log message ***
 *
 * Revision 1.17  1995/10/25  17:22:07  mju
 * Move FONTSTYLE flags to stddefns.h.
 *
 * Revision 1.16  1995/08/28  16:59:06  scowan
 * Changed MfReadTextStyle() API.
 *
 * Revision 1.15  1995/08/28  16:33:32  scowan
 * Prototyped new MfFontTrans...() functions.
 *
 * Revision 1.14  1995/08/25  20:12:40  scowan
 * Added prototype for MfReadTextStyleExt().
 *
 * Revision 1.13  1995/07/26  13:24:58  mju
 * Add FontTrans... prototypes.
 *
 * Revision 1.12  1995/01/30  20:49:00  scowan
 * Added prototypes for MfDeleteStyle() and MfDeletePattern().
 *
 * Revision 1.11  1995/01/12  00:30:37  scowan
 * Added HeightUnits and LineSpaceUnits fields to RVCTEXTSTYLE.
 *
 * Revision 1.10  1994/06/30  14:07:36  coffee!dwilliss
 * Added PATTCOLOR_Variable.  Same as UserDefined, but more intuitively named.
 *
 * Revision 1.9  1994/05/06  21:54:54  scowan
 * Changed int to UINT32 in MfCombineStyles().
 *
 * Revision 1.8  1994/05/06  15:06:57  scowan
 * Changed long to INT32.
 * Changed flag parms to UINT32.
 *
 * Revision 1.7  1993/12/27  15:07:33  coffee!dwilliss
 * Added MapScale to RVCxxxxSTYLE structures
 *
 * Revision 1.6  1993/11/12  20:56:24  coffee!dwilliss
 * *** empty log message ***
 *
 * Revision 1.5  1993/08/06  19:43:16  shovland
 * added prototype for MfCombineStyles()
 *
 * Revision 1.4  1993/05/17  20:31:25  coffee!harrison
 * Added prototype for MfMakeDftStyleTable...
 *
 * Revision 1.3  1993/04/14  16:31:12  mju
 * Add MxFillPolygonBitmapW() prototype.
 *
 * Revision 1.2  1993/01/06  18:14:24  mju
 * Change API for MxFillPolygonsBitmap()
 *
 * \endif
**/

#ifndef INC_MI32_RVCSTYLE_H
#define INC_MI32_RVCSTYLE_H

#ifndef INC_RVC_OBJECTNAME_H
	#include <rvc/objectname.h>
#endif

#ifndef	INC_MI32_ELEMSTYL_H
	#include <mi32/elemstyl.h>
#endif

#ifndef GENERATING_DOXYGEN_OUTPUT
// Forward declarations
class FILEPATH;
namespace RVC {
	class OBJITEM;
	class STYLE;
	}
#endif

/*----------------------------------------------------------------------------*/
/*		Definitions for style structures as stored in file								*/
/*----------------------------------------------------------------------------*/

//! Structure for point drawing style.
DEPRECATED struct RVCPOINTSTYLE {
	RVC::OBJECTNAME name;					//!< Name
	UINT32 StyleFlags;						//!< Flags
	INT32 SymbolNum;							//!< Symbol number
	DOUBLE ScaleX;								//!< Size in mm
	DOUBLE ScaleY;								//!< Size in mm
	DOUBLE Angle;								//!< Angle in radians (?)
	COLOR DrawColor;							//!< Color
	DOUBLE MapScale;							//!< MapScale to use given scales at
	};

//! Structure for line drawing style.
DEPRECATED struct RVCLINESTYLE {
	RVC::OBJECTNAME name;					//!< Name
	UINT32 StyleFlags;						//!< Flags
	INT32 PatternNum;							//!< Pattern number
	DOUBLE Scale;								//!< Actually line width in mm
	COLOR DrawColor;							//!< Color
	DOUBLE MapScale;							//!< MapScale to use given scales at
	};

//! Structure for polygon drawing style.
DEPRECATED struct RVCPOLYGONSTYLE {
	RVC::OBJECTNAME name;					//!< Name
	UINT32 StyleFlags;						//!< Flags
	INT32 FillPatternNum;					//!< Fill pattern number
	INT32 BorderPatternNum;					//!< Border pattern number
	UINT8 space[4];							//!< Spacing
	DOUBLE BorderScale;						//!< Actually line width in mm
	COLOR BorderColor;						//!< Border color
	COLOR FillColor;							//!< Fill color
	DOUBLE MapScale;							//!< MapScale to use given scales at
	};
DEPRECATED typedef RVCPOLYGONSTYLE RVCPOLYSTYLE;

//! Structure for text drawing style.
DEPRECATED struct RVCTEXTSTYLE {
	RVC::OBJECTNAME name;					//!< Name
	UINT32 StyleFlags;						//!< Flags
	INT32 font;									//!< Font
	COLOR fgcolor;								//!< Foreground color
	COLOR bgcolor;								//!< Background color
	FLOAT glyphrot;							//!< Glyph rotation
	FLOAT glyphaspect;						//!< Glyph aspect
	FLOAT shear;								//!< Shear
	FLOAT height;								//!< Height
	FLOAT linespace;							//!< Line spacing
	UINT32 FontFlags;							//!< Font flags
	DOUBLE MapScale;							//!< MapScale to use given scales at
	UINT8 HeightUnits;						//!< Defined in SCREENUNITS_...
	UINT8 LineSpaceUnits;					//!< Line spacing units
	UINT16 Predefined;						//!< ???
	FLOAT width;								//!< Only used for HTML layout
	FLOAT StrokeWidth;						//!< Stroke width in % of glyph height (1.0 = 100%)
	FLOAT EnhanceWidth;						//!< Enhanced width in % of glyph height (1.0 = 100%)
	FLOAT BoldnessWidth;						//!< Boldness width in % of glyph height (1.0 = 100%) Ignored unless FONTSTYLE_Bold is set
	FLOAT UnderlineWidth;					//!< Underline with in % of glyph height (1.0 = 100%)
	FLOAT UnderlineOffset;					//!< Underline Offset from baseline in % (1.0 = 100%)
	FLOAT ShadowOffset;						//!< Drop shadow offset in % (1.0 = 100%) Ignored unless FONTSTYLE_Shadow is set
	FLOAT ShadowAngle;						//!< Drop shadow angle in radians
	FLOAT ClipWidth;							//!< Clip extended area around text in TextAddToClip()
	UINT8 ShadowRelative;					//!< true if shadow angle relative to baseline angle
	UINT8 WidthUnits;
	UINT8 space[6];
	};

//! Enumeration for style types.
DEPRECATED enum STYLETYPE {
	STYLETYPE_Point =		0,
	STYLETYPE_Line =		1,
	STYLETYPE_Polygon =	2,
	STYLETYPE_Text =		3,
	STYLETYPE_COUNT =		4,
	STYLETYPE_Empty =		0xFFFF,
	};
#define	STYLETYPE_Poly			STYLETYPE_Polygon
#define	NUMSTYLETYPES			STYLETYPE_COUNT

//! Enumeration for pattern types.
DEPRECATED enum PATTERNTYPE {
	PATTERNTYPE_Symbol =	0,
	PATTERNTYPE_Line =	1,
	PATTERNTYPE_Bitmap =	2,
	PATTERNTYPE_Hatch =	3,
	PATTERNTYPE_COUNT =	4,
	};
#define	NUMPATTTYPES			PATTERNTYPE_COUNT

//! Information common to all patterns / symbols.
DEPRECATED struct RVCPATTHDR {
	RVC::OBJECTNAME name;					//!< Name
	INT16 numelements;						//!< Number of elements used to define pattern
	INT16 numcolors;							//!< Number of colors used in pattern
	};
	

/*----------------------------------------------------------------------------*/
/*		Definitions for bitmap pattern description structure							*/
/*																										*/
/*			Each pattern entry consists of a header (BITMAPPATTHDR), followed by	*/
/*			the color map (array of COLORs with "numcolors" entries), followed	*/
/*			by the pattern (array of UBYTES with "xsize" * "ysize" elements.		*/
/*----------------------------------------------------------------------------*/

//! Bitmap pattern header.
struct BITMAPPATTHDR : public RVCPATTHDR {
	INT16 xsize;								//!< X size
	INT16 ysize;								//!< Y size
	INT16 xhot;									//!< X hot					
	INT16 yhot;									//!<	Y hot
	INT16 xspace;								//!< X space
	INT16 yspace;								//!< Y space
	};


/*----------------------------------------------------------------------------*/
/*		Definitions for line pattern description structure								*/
/*																										*/
/*			Each pattern entry consists of a header (LINEPATTHDR), followed by	*/
/*			the color map (array of COLORs with "numcolors" entries), followed	*/
/*			by the pattern elements.															*/
/*			All position and size values are in units of 1/100 millimeter.			*/
/*----------------------------------------------------------------------------*/

//! Line pattern header.
struct LINEPATTHDR : public RVCPATTHDR {
	INT16 extentsa;							//!< Maximum extents of element "above" line (drawn left to right)
	INT16 extentsb;							//!< Maximum extents of element "below" line (drawn left to right)
	};

struct LINEPATTELEM {
	INT16 extrabytes;							//!< Number of bytes in element not including header
	UINT8 type;									//!< Pattern element type
	UINT8 colornum;							//!< Color index in pattern-specific color map
	UINT16 flags;								//!< Flags
	INT16 xoffset;								//!< Offset along line from start
	INT16 xspacing;							//!< Spacing between instances of element
	INT16 yoffset;								//!< Offset above(-) or below(+) line
	INT16 xsize;								//!< Size/Length of element
	INT16 thickness;							//!< Thickness of element lines (if not filled)
	};

#define	LINEPATTELEM_Line			0		//!< Line parallel to drawing direction, xsize=0 indicates continuous
#define	LINEPATTELEM_CrossLine	1		//!< Line perpendicular to drawing direction
#define	LINEPATTELEM_Circle		2		//!< Circle - xsize = radius
#define	LINEPATTELEM_PolyLine	3		//!< PolyLine
#define	LINEPATTELEM_Polygon		4		//!< Polygon

#define	LINEPATTELEM_Last			4		//!< Last defined type

#define	LINEPATTFLAG_Filled		0x0001//!< Fill (circle and polygon elements)
#define	LINEPATTFLAG_JoinMiter	0x0002//!< Join "bent" segment mitered (extended)
#define	LINEPATTFLAG_JoinBevel	0x0004//!< Join "bent" segment beveled
#define	LINEPATTFLAG_CapRound	0x0008//!< Use rounded ends on line segments


/*----------------------------------------------------------------------------*/
/*		Definitions for hatch pattern description structure							*/
/*																										*/
/*			Each pattern entry consists of a header (HATCHPATTHDR), followed by	*/
/*			the color map (array of COLORs with "numcolors" entries), followed	*/
/*			by the pattern elements.															*/
/*			All position and size values are in units of 1/100 millimeter.			*/
/*----------------------------------------------------------------------------*/

//! Hatch pattern header.
struct HATCHPATTHDR : public RVCPATTHDR {
	UINT8 spare[4];							//!< Double alignment
	};

//! Hatch pattern element structure.
struct HATCHPATTELEM {
	UINT8 type;									//!< Pattern element type: simple or line pattern
	UINT8 colornum;							//!< Color index in pattern-specific color map
	UINT8 isvisible;							//!< Flag for turning element on/off
	UINT8 space;								//!< Space
	UINT32 linedatasize;						//!< Size of the line pattern data attached
	UINT32 flags;								//!< Flags
	UINT8 spare[4];							//!< Double alignment
	DOUBLE xoffset;							//!< Origin offset
	DOUBLE yoffset;							//!< Origin offset
	DOUBLE spacing;							//!< Spacing between instances of element
	DOUBLE angle;								//!< Angle of element
	DOUBLE thickness;							//!< Thickness of element lines
	};

#define	HATCHPATTELEM_Simple			0	//!< Simple solid lines
#define	HATCHPATTELEM_LinePattern	1	//!< Line pattern
#define	HATCHPATTELEM_SolidFill		2	//!< Fill with solid color
#define	HATCHPATTELEM_Last			2	//!< Last defined type

/*----------------------------------------------------------------------------*/
/*		Definitions for symbol description structure										*/
/*																										*/
/*			Each pattern entry consists of a header (SYMBOLHDR), followed by		*/
/*			the color map (array of COLORs with "numcolors" entries), followed	*/
/*			by the symbol elements.																*/
/*			All position and size values are in units of 1/100 millimeter.			*/
/*----------------------------------------------------------------------------*/

//! Symbol header.
struct SYMBOLHDR : public RVCPATTHDR {
	INT16 xsize;								//!< X size
	INT16 ysize;								//!< Y size
	INT16 xhot;									//!< X hot
	INT16 yhot;									//!< Y hot
	UINT16 flags;								//!< Flags
	UINT8 spare[2];							//!< Double alignment
	};

#define SYMBOLHDRFLAG_OldSymbol		(0x8000)

/* rotation and angles are in 1/64th of a degree */

union SYMBOLDATA {
	struct { INT16 x, y, radius; } circle;
	struct { INT16 x, y, radius, sangle, eangle; } arc;
	struct { INT16 x, y, xsize, ysize, rotate; } ellipse;
	struct { INT16 x, y, xsize, ysize, sangle, eangle, rotate; } earc;
	struct { INT16 x, y; } point;
	struct { INT16 x1, y1, x2, y2; UINT16 capstyle; } segment;
	struct { INT16 x, y, xsize, ysize, rotate, shear; UINT16 joinstyle; } rectangle;
	struct { UINT16 numpoints, joinstyle, capstyle; } line;
	struct { UINT16 numpoints, joinstyle; } polygon;
	struct { UINT16 numchars, fontnum, fontstyle, flags;
				INT16 x, y, height, rotate, shear, textrot, xscale; } text;
	struct { UINT16 numpoints, joinstyle, capstyle; } spline;
	struct { UINT16 numpoints, joinstyle, capstyle; } ttfsymbol;
	struct { UINT16 numpoints, joinstyle, numpolys; } polygons;
	INT16 spare[12];
	};

//! Symbol element structure.
struct SYMBOLELEM {
	SYMBOLDATA data;							//!< Union of element structures
	UINT32 numbytes;							//!< Number of bytes
	INT16 thickness;							//!< Thickness of element lines (if not filled)
	UINT16 flags;								//!< Flags
	UINT8 type;									//!< Type of element stored
	UINT8 colornum;							//!< Color index in pattern-specific color map
	UINT8 spare[2];							//!< Double alignment
	};

/* Extra bytes for lines, text, and polygons */

/* Defined types */
#define PTSYM_NULL			0				//!< Empty element, maybe for deletes?
#define PTSYM_Circle			1
#define PTSYM_Arc				2 	
#define PTSYM_ArcWedge		3
#define PTSYM_ArcChord		4
#define PTSYM_Ellipse		5
#define PTSYM_EArc			6
#define PTSYM_EArcWedge		7
#define PTSYM_EArcChord		8
#define PTSYM_Line			9
#define PTSYM_Polygon		10
#define PTSYM_Point			11
#define PTSYM_Text			12
#define PTSYM_Segment		13
#define PTSYM_Rectangle		14
#define PTSYM_Polygons		15				//!< Multiple polygons with islands
#define PTSYM_Splines		16				//!< Splines of the type used in TrueType

#define PTSYM_Last			16				//!< Last element type defined

#define	SYMBOLFLAG_Filled		0x0001	//!< Fill polygonal elements

/*----------------------------------------------------------------------------*/
/*		Function prototypes																		*/
/*----------------------------------------------------------------------------*/

//! Import point symbols from RVC CAD blocks.
//! If the CAD object only has one block, it is converted to a symbol.
//! If the CAD object has > 1 block, the first block is ignored and all the
//! other blocks are imported using the block names for new symbol names.
ERRVALUE MfImportPointSymbolsFromCAD (
	RVC::STYLE& StyleObj,					//!< Style object to import to
	const RVC::OBJITEM& ObjItemCAD		//!< CAD object to import from
	);

//! Create a point symbol from a CGM (Computer Graphics Metafile) file
ERRVALUE MfImportPointSymbolFromCGM (
	RVC::STYLE& StyleObj,					//!< Style object to import to
	const RVC::OBJECTNAME& SymbolName,	//!< Name to give the new symbol
	const FILEPATH& FilePathCGM			//!< Path to CGM file
	);

//! Create a point symbol from a TrueType glyph
ERRVALUE MfImportPointSymbolFromTTF (	
	RVC::STYLE& StyleObj,					//!< Style object to import to
	const RVC::OBJECTNAME& SymbolName,	//!< Name to give the new symbol
	const MIUNICODE* FontName,				//!< Name for TrueType font to read from
	int GlyphIndex								//!< Glyph Index (not ASCII or Unicode value)
	);

#endif		//!<  INC_MI32_RVCSTYLE_H 

